indexing
	description: "Suppressions of pre- and postconditions of exported features by class invariants"
	author: "Markus Pilman"
	date: "$Date$"
	revision: "$Revision$"

class
	CI_INVARIANT_SUPPRESSION

inherit
	CI_SUPPRESSION

create
	make

feature -- Variable renaming
	renamed_current (a_variable: CI_CURRENT): CI_VARIABLE is
			-- Name of `a_variable' in the `suppressor'
		do
			Result := a_variable
		end

	renamed_argument (a_variable: CI_FORMAL_ARGUMENT): CI_VARIABLE is
			-- Name of `a_variable' in the `suppressor'
		do
		end

	renamed_local (a_variable: CI_LOCAL_ENTITY): CI_VARIABLE is
			-- Name of `a_variable' in the `suppressor'
		do
		end

	renamed_result (a_variable: CI_RESULT): CI_VARIABLE is
			-- Name of `a_variable' in the `suppressor'
		local
			target: CI_CURRENT
		do
			if a_variable.surrounding_routine.arguments_count = 0 then
				create target.make (Void, a_variable.type.surrounding_class, a_variable.type.universe)
				create {CI_QUERY} Result.make (a_variable.surrounding_routine, target)
			end
		end
end
