indexing
	description: "Objects that measure execution time"
	author: ""
	date: "$Date$"
	revision: "$Revision$"

class
	CI_STOPWATCH

feature -- Access
	duration: TIME_DURATION is
			-- Time duration last recorded by the stopwatch
		do
			Result := stop_time.relative_duration (start_time)
		end

	fine_seconds: DOUBLE is
			-- Number of seconds last recorded by the stopwatch
		do
			Result := duration.fine_second
		end
		
feature -- Basic operations
	tick is
			-- Record start time
		do
			start_time.make_now
		end

	tock is
			-- Record stop time
		do
			stop_time.make_now
		end

feature {NONE} -- Implementation
	start_time: TIME is
			-- Start time
		once
			create Result.make (0, 0, 0)
		end

	stop_time: TIME is
			-- Start time			
		once
			create Result.make (0, 0, 0)
		end
end
