indexing
	description: "Objects that store and retrieve other objects (useful for non-storable objects)"
	author: "Nadia Polikarpova"
	date: "$Date$"
	revision: "$Revision$"

class
	CI_STORER [G]

inherit
	STORABLE
		export {NONE}
			all
		end

feature -- Access
	item: G
			-- Retrieved object

feature -- Basic operations
	store_item (an_item: G; a_file_name: FILE_NAME) is
			-- Store `an_item' to file called `a_file_name'
		do
			item := an_item
			store_by_name (a_file_name)
			item := Void
		end

	retrieve_item (a_file_name: FILE_NAME) is
			-- Retrive object from file called `a_file_name'
		local
			storer: like Current
		do
			storer ?= retrieve_by_name (a_file_name)
			if storer /= Void then
				item := storer.item
			end
		end

end
